#
# Microlog. Copyright (c) 2023 laffra, dcharbon. All rights reserved.
#

__version__ = "1.3.6"

import sys

from .api import info, warn, debug, error
from .api import start, stop
from .api import heap
from .api import enabled

try:
    from . import server
except:
    pass # the server is not included in the UI

try:
    import js, pyodide
    button = js.document.createElement('button')
    button.style.cssText = 'position: fixed; background-color: orange; z-index: 999; bottom:10px; right: 10px;'
    button.innerText = "Start Microlog"
    def toggleMicrolog(event):
        if button.innerText == "Start Microlog":
            button.innerText = "Stop Microlog"
            start("PyScript")
        else:
            button.innerText = "Start Microlog"
            stop()
    button.addEventListener("click", pyodide.ffi.create_proxy(toggleMicrolog))
    js.document.body.appendChild(button)
except Exception as e:
    sys.stdout.write(f"{e}\n")
    pass # do not show microlog UI if not running in PyScript